# QVM: Quaternions, Vectors, Matrices

### boost/qvm/swizzle.hpp

This header provides generic Swizzling support for vector objects.

### Synopsis:

#include <boost/qvm/swizzle.hpp>

    namespace boost
    {
        namespace qvm
        {
            //2D view proxies, only enabled if:
            //  is_vec<V>::value
            template <class V> -unspecified-2D-vector-type- XX( V & v );
            template <class V> -unspecified-2D-vector-type- XY( V & v );
            template <class V> -unspecified-2D-vector-type- XZ( V & v );
            template <class V> -unspecified-2D-vector-type- XW( V & v );
            template <class V> -unspecified-2D-vector-type- X0( V & v );
            template <class V> -unspecified-2D-vector-type- X1( V & v );
            template <class V> -unspecified-2D-vector-type- YX( V & v );
            template <class V> -unspecified-2D-vector-type- YY( V & v );
            template <class V> -unspecified-2D-vector-type- YZ( V & v );
            template <class V> -unspecified-2D-vector-type- YW( V & v );
            template <class V> -unspecified-2D-vector-type- Y0( V & v );
            template <class V> -unspecified-2D-vector-type- Y1( V & v );
            template <class V> -unspecified-2D-vector-type- ZX( V & v );
            template <class V> -unspecified-2D-vector-type- ZY( V & v );
            template <class V> -unspecified-2D-vector-type- ZZ( V & v );
            template <class V> -unspecified-2D-vector-type- ZW( V & v );
            template <class V> -unspecified-2D-vector-type- Z0( V & v );
            template <class V> -unspecified-2D-vector-type- Z1( V & v );
            template <class V> -unspecified-2D-vector-type- WX( V & v );
            template <class V> -unspecified-2D-vector-type- WY( V & v );
            template <class V> -unspecified-2D-vector-type- WZ( V & v );
            template <class V> -unspecified-2D-vector-type- WW( V & v );
            template <class V> -unspecified-2D-vector-type- W0( V & v );
            template <class V> -unspecified-2D-vector-type- W1( V & v );
            ...
            //2D view proxies, only enabled if:
            //  is_scalar<S>::value
            template <class S> -unspecified-2D-vector-type- X0( S & s );
            template <class S> -unspecified-2D-vector-type- X1( S & s );
            template <class S> -unspecified-2D-vector-type- XX( S & s );
            ...
            -unspecified-2D-vector-type- _00();
            -unspecified-2D-vector-type- _01();
            -unspecified-2D-vector-type- _10();
            -unspecified-2D-vector-type- _11();

            //3D view proxies, only enabled if:
            //  is_vec<V>::value
            template <class V> -unspecified-3D-vector-type- XXX( V & v );
            ...
            template <class V> -unspecified-3D-vector-type- XXW( V & v );
            template <class V> -unspecified-3D-vector-type- XX0( V & v );
            template <class V> -unspecified-3D-vector-type- XX1( V & v );
            template <class V> -unspecified-3D-vector-type- XYX( V & v );
            ...
            template <class V> -unspecified-3D-vector-type- XY1( V & v );
            ...
            template <class V> -unspecified-3D-vector-type- WW1( V & v );
            ...
            //3D view proxies, only enabled if:
            //  is_scalar<S>::value
            template <class S> -unspecified-3D-vector-type- X00( S & s );
            template <class S> -unspecified-3D-vector-type- X01( S & s );
            ...
            template <class S> -unspecified-3D-vector-type- XXX( S & s );
            template <class S> -unspecified-3D-vector-type- XX0( S & s );
            ...
            -unspecified-3D-vector-type- _000();
            -unspecified-3D-vector-type- _001();
            -unspecified-3D-vector-type- _010();
            ...
            -unspecified-3D-vector-type- _111();

            //4D view proxies, only enabled if:
            //  is_vec<V>::value
            template <class V> -unspecified-4D-vector-type- XXXX( V & v );
            ...
            template <class V> -unspecified-4D-vector-type- XXXW( V & v );
            template <class V> -unspecified-4D-vector-type- XXX0( V & v );
            template <class V> -unspecified-4D-vector-type- XXX1( V & v );
            template <class V> -unspecified-4D-vector-type- XXYX( V & v );
            ...
            template <class V> -unspecified-4D-vector-type- XXY1( V & v );
            ...
            template <class V> -unspecified-4D-vector-type- WWW1( V & v );
            ...
            //4D view proxies, only enabled if:
            //  is_scalar<S>::value
            template <class S> -unspecified-4D-vector-type- X000( S & s );
            template <class S> -unspecified-4D-vector-type- X001( S & s );
            ...
            template <class S> -unspecified-4D-vector-type- XXXX( S & s );
            template <class S> -unspecified-4D-vector-type- XX00( S & s );
            ...
            -unspecified-4D-vector-type- _0000();
            -unspecified-4D-vector-type- _0001();
            -unspecified-4D-vector-type- _0010();
            ...
            -unspecified-4D-vector-type- _1111();
        }
    }

See also: Accessing Vector Elements by Swizzling | boost/qvm/swizzle2.hpp | boost/qvm/swizzle3.hpp | boost/qvm/swizzle4.hpp | Code Generator